///////////////////////////////////////////////////////////////////////////
// Details.c
//
// the Details form

#ifndef _MAIN_H
#include "main.h"
#endif

#ifndef _DETAILS_H
#include "details.h"
#endif

#ifndef _UTIL_H
#include "util.h"
#endif

#include "res.h"



///////////////////////////////////////////////////////////////////////////
// Details Form

static void DetailsCleanup(void)
{
	Int			ii;
#if 0
	FormPtr		pfrm = FrmGetActiveForm();
	CharPtr		psz = FrmGetTitle(pfrm);
#endif

	Assert(FrmGetActiveForm());
	Assert(FrmGetActiveFormID() == FRM_DETAILS);

	for (ii = g_cStores; ii--;)
		{
		MemPtrFree(CtlGetLabel(GetObjectPtr(IDC_DETAILS_STORES+ii)));
		//$ review: (chrisant) probably not necessary
		CtlSetLabel(GetObjectPtr(IDC_DETAILS_STORES+ii), 0);
		}

#if 0
	// free title if we allocated it
	if (StrLen(psz) > 6 /*spaces*/ + 7 /*"Details"*/)
		{
		// it's longer than the default title therefore we allocated it
		MemPtrFree(FrmGetTitle(pfrm));
		}
#endif
}


static Boolean DetailsApply(void)
{
	UInt		attr;
//	Boolean		fSecret;
	Boolean		fDirty = fFalse;		// P11. If an attribute changed
	Boolean		fDirtyContents = fFalse;		// if item contents changed
	VoidHand	h;
	Item		*pitem;
	UInt		store;
	UChar		flags;
	Int			ii;
	Boolean		fReset = fFalse;

	Assert(sizeof(flags) == sizeof(pitem->flags));
	Assert(sizeof(store) == sizeof(pitem->store));

	// get attributes of the current record
	DmRecordInfo(g_pdb, recCurrent, &attr, NULL, NULL);

#if 0
	// Has the secret attribute been changed?
	fSecret = (CtlGetValue(GetObjectPtr(IDC_DETAILS_PRIVATE)) != 0);
	if (((attr & dmRecAttrSecret) == dmRecAttrSecret) != fSecret)
		{
		// Yes, it was changed.  What is the new setting?
		if (fSecret)
			// Now it should be secret.
			attr |= dmRecAttrSecret;
		else
			// Now it should not be secret.
			attr &= ~dmRecAttrSecret;

		fDirty = fTrue;
		}
#endif

	Assert(!(attr & (dmRecAttrDelete|dmRecAttrSecret)));

	// P11. Has the category been changed?
	if (catRecord != catNew)
		{
		attr &= ~dmRecAttrCategoryMask;			// Remove all category bits.
		attr |= catNew;							// Set the new category
		fDirty = fTrue;							// mark this record dirty later
		catRecord = catNew;						// remember which category the record is in
		fReset = fTrue;
		}

	// P11. If the current category was deleted, renamed, or merged with
	// another category, then the list view needs to be redrawn.
	if (g_fNewCategoryEdited)
		{
		catRecord = catNew;
		fReset = fTrue;
		}

	if (fDirty)
		{
		// Set the dirty flag for the record.
		attr |= dmRecAttrDirty;
		DmSetRecordInfo(g_pdb, recCurrent, &attr, NULL);
		}

	// get item pointer
	h = DmGetRecord(g_pdb, recCurrent);
	pitem = MemHandleLock(h);

	flags = pitem->flags;
	flags &= ~flagPrivate;
	if (CtlGetValue(GetObjectPtr(IDC_DETAILS_PRIVATE)))
		flags |= flagPrivate;
#if 0
	flags &= ~flagCoupon;
	if (CtlGetValue(GetObjectPtr(IDC_DETAILS_COUPON)))
		flags |= flagCoupon;
#endif

	store = CtlGetValue(GetObjectPtr(IDC_DETAILS_ONCE)) ? storeOnce : 0;
	for (ii = g_cStores; ii--;)
		if (CtlGetValue(GetObjectPtr(IDC_DETAILS_STORES+ii)))
			store |= g_rgStores[ii+1].bit;

	if (store != pitem->store || flags != pitem->flags)
		{
		if (pitem->flags & flagNeed)
			{
			UpdateCounts(-1, pitem->store);
			UpdateCounts(1, store);
			}
		DmWrite(pitem, OffsetOf(*pitem, flags), &flags, sizeof(flags));
		DmWrite(pitem, OffsetOf(*pitem, store), &store, sizeof(store));
		fDirtyContents = fTrue;
		}
	if (store != pitem->store)
		fReset = fTrue;

	store &= ~storeOnce;	// remove this bit, we don't care about it anymore
	if (g_store && !(g_store & store))
		g_store = store;
	if (catCurrent != dmAllCategories && catNew != catCurrent)
		catCurrent = catNew;

	MemHandleUnlock(h);
	DmReleaseRecord(g_pdb, recCurrent, fDirtyContents);

	return fReset;
}


static void DetailsInit(void)
{
	ControlPtr		pctl;
	FormPtr			pfrm;
	UInt			attr;
//	Boolean			fSecret;
	VoidHand		h;
	Item			*pitem;
	Int				ii;
	Int				cxMax;
	CharPtr			psz;
#if 0
	CharPtr			pszTitle;
#endif

	pfrm = FrmGetActiveForm();

	// get category attributes of current record
	DmRecordInfo(g_pdb, recCurrent, &attr, NULL, NULL);
	catRecord = attr & dmRecAttrCategoryMask;
//	fSecret = attr & dmRecAttrSecret;

	// P11. NewCategory indicates which category wants to changed the
	// current record to.  Initialize it to the current record's current
	// category.
	catNew = catRecord;
	g_fNewCategoryEdited = fFalse;

	// get RecordData
	h = DmQueryRecord(g_pdb, recCurrent);
	Assert(h);
	pitem = MemHandleLock(h);
//	CtlSetValue(GetObjectPtr(IDC_DETAILS_COUPON), F(pitem->flags & flagCoupon));
	CtlSetValue(GetObjectPtr(IDC_DETAILS_ONCE), F(pitem->store & storeOnce));
	CtlSetValue(GetObjectPtr(IDC_DETAILS_PRIVATE), F(pitem->flags & flagPrivate));

	for (ii = g_cStores; ii--;)
		{
		if (g_cStores <= 8 || (ii > (Int)((g_cStores-1) % 8) && ii <= (Int)(g_cStores-1)))
			cxMax = 160-16;
		else
			cxMax = 80-16;

		pctl = GetObjectPtr(IDC_DETAILS_STORES+ii);
		CtlSetValue(pctl, F(pitem->store & g_rgStores[ii+1].bit));
		CtlSetUsable(pctl, fTrue);

		psz = MemPtrNew(StrLen(g_rgStores[ii+1].pszName)+1 _MEMTRACK);
		if (psz)
			{
			StrCopy(psz, g_rgStores[ii+1].pszName);
			TruncateLabel(psz, cxMax);
			CtlSetLabel(pctl, psz);
			}
		}

#if 0
	psz = FrmGetTitle(pfrm);
	cxMax = StrLen(psz) + 5 /*" for "*/ + 1 /*null*/;
	cxMax += pitem->cchName ? pitem->cchName : 8 /*"new item"*/;
	pszTitle = MemPtrNew(cxMax _MEMTRACK);
	if (pszTitle)
		{
		StrCopy(pszTitle, psz);
		StrCat(pszTitle, " for ");
		StrCat(pszTitle, pitem->cchName ? pitem->szName : "new item");
		FrmSetTitle(pfrm, pszTitle);
		}
#endif

	MemHandleUnlock(h);

//	CtlSetValue(GetObjectPtr(IDC_DETAILS_PRIVATE), fSecret);

	// P11. Set the label of the category trigger.
	CategoryGetName(g_pdb, catRecord, szCategoryName);
	pctl = GetObjectPtr(IDC_CATEGORY_TRIGGER);
	CategorySetTriggerLabel(pctl, szCategoryName);

	FrmDrawForm(pfrm);
	DrawHelpButton(pfrm, IDC_HELP);
}


Boolean DetailsFormHandleEvent(EventPtr pEvent)
{
	Boolean		fHandled = fTrue;

	CALLBACK_PROLOGUE

	switch (pEvent->eType)
		{
		case ctlSelectEvent:
			// A control button was pressed and released.
			switch (pEvent->data.ctlSelect.controlID)
				{
				case IDC_FORM_OK:
					// The ok button was pressed so apply the changes.
					if (DetailsApply())
						{
						// may have affected the view, so totally refresh form
						FrmCloseAllForms();
						FrmGotoForm(FRM_MAIN);
						break;
						}
					// fall thru
				case IDC_FORM_CANCEL:
					DetailsCleanup();
					FrmReturnToForm(0);
					RestoreInsPt();
					break;

				case IDC_DETAILS_DELETE:
					// The delete button was pressed.  Delete the current record.
					if (FrmCustomAlert(ALT_CONFIRM,
									   IfGerman("Diesen Artikel lschen?")
									   IfEnglish("Delete this item?")
									   , "", "") == 0)
						{
						DeleteRecord(recCurrent);
						FrmCloseAllForms();
						FrmGotoForm(FRM_MAIN);
						}
					break;

				case IDC_CATEGORY_TRIGGER:
					// P11. The category trigger was pressed.  Have the
					// system ui present a list of categories and return
					// what the user selects.  The categories listed are those
					// found in the app info block.
					if (CategorySelectV10(g_pdb, FrmGetActiveForm(),
										  IDC_CATEGORY_TRIGGER,
										  IDC_CATEGORY_LIST,
										  fFalse, &catNew, szCategoryName))
						{
						g_fNewCategoryEdited = fTrue;
						}
					break;

				case IDC_HELP:
					FrmHelp(STR_DETAILS_HELP);
					break;

				default:
					fHandled = fFalse;
					break;
				}
			break;

		case frmOpenEvent:
			DetailsInit();
			break;

		case frmCloseEvent:
			DetailsCleanup();
			// frmCloseEvent does NOT get sent by FrmReturnToForm.  must
			// delete the form when closed other than by FrmReturnToForm.
			FrmDeleteForm(FrmGetActiveForm());
			break;

		default:
			fHandled = fFalse;
		}

	CALLBACK_EPILOGUE
	return fHandled;
}


///////////////////////////////////////////////////////////////////////////
// Quantity Form

Boolean QuantityFormHandleEvent(EventPtr pEvent)
{
	Boolean		fHandled = fTrue;
	TablePtr	ptbl;
	Word		row;
	UInt		uQuantity;

	CALLBACK_PROLOGUE

	switch (pEvent->eType)
		{
		case ctlSelectEvent:
			switch (pEvent->data.ctlSelect.controlID)
				{
				case IDC_FORM_OK:
					{
					FieldPtr pfld;
					CharPtr psz;
					VoidHand h;
					Item *pitem;

					Assert(sizeof(uQuantity) == sizeof(pitem->uQuantity));

					pfld = GetObjectPtr(IDC_QUANTITY);
					if (FldDirty(pfld))
						{
						psz = FldGetTextPtr(pfld);
						if (psz)
							{
							uQuantity = StrAToI(psz);
							h = DmGetRecord(g_pdb, recCurrent);
							if (h)
								{
								pitem = MemHandleLock(h);
								DmWrite(pitem, OffsetOf(*pitem, uQuantity),
										&uQuantity, sizeof(pitem->uQuantity));
								MemHandleUnlock(h);
								DmReleaseRecord(g_pdb, recCurrent, fTrue);
								}
							}
						}
					}
					// fall thru
				case IDC_FORM_CANCEL:
					FrmReturnToForm(0);

					ptbl = GetObjectPtr(IDC_TABLE);
					TblFindRowData(ptbl, recCurrent, &row);
					if (pEvent->data.ctlSelect.controlID == IDC_FORM_OK)
						TblSetItemInt(ptbl, row, COL_QUANTITY, uQuantity);
					TblMarkRowInvalid(ptbl, row);
					TblRedrawTable(ptbl);

					RestoreInsPt();
					break;

				default:
					fHandled = fFalse;
					break;
				}
			break;

		case menuEvent:
			fHandled = HandleEditMenu(pEvent);
			break;

		case frmOpenEvent:
			{
			FormPtr pfrm = FrmGetActiveForm();
			Char sz[10];
			VoidHand h;
			Item *pitem;
			FieldPtr pfld = GetObjectPtr(IDC_QUANTITY);
			Int cch;

			Assert(recCurrent != noRecordSelected);

			h = DmQueryRecord(g_pdb, recCurrent);
			if (h)
				{
				pitem = MemHandleLock(h);
				StrIToA(sz, pitem->uQuantity);
				MemHandleUnlock(h);

				cch = StrLen(sz);
				Verify(FldInsert(pfld, sz, cch));

				//$ review: (chrisant) this doesn't work as advertised
				//FldSetSelection(pfld, 0, cch);
				FldSetInsPtPosition(pfld, cch);
				}
			FrmDrawForm(pfrm);

			FrmSetFocus(pfrm, FrmGetObjectIndex(pfrm, IDC_QUANTITY));
			}
			break;

		case frmCloseEvent:
			// this does NOT get sent by FrmReturnToForm.  must delete the
			// form when closed other than by FrmReturnToForm.
			FrmDeleteForm(FrmGetActiveForm());
			break;

		default:
			fHandled = fFalse;
		}

	CALLBACK_EPILOGUE
	return fHandled;
}



