///////////////////////////////////////////////////////////////////////////
// util.h

#ifdef _UTIL_H
#error _UTIL_H already defined!
#else
#define _UTIL_H
#endif


#ifndef _MAIN_H
#include "main.h"
#endif

#ifndef _SHOP_H
#include "shop.h"
#endif




#define DimensionOf(x) (sizeof(x) / sizeof(*(x)))
#define OffsetOf(struc, member) ((ULong)&(struc).member - (ULong)&(struc))
#define AssertSameSize(a, b) Assert(sizeof(a) == sizeof(b))

#define CheckErr(x) do { err = (x); if (err) goto Error; } while (fFalse)
#define CheckErrVoid(x) do { if (x) goto Error; } while (fFalse)
#define CE(x) CheckErr(x)
#define CEv(x) CheckErrVoid(x)
#define CPE(p) do { if (!(p)) {err = memErrNotEnoughSpace; goto Error;} } while (fFalse)
#define CPEv(p) do { if (!(p)) goto Error; } while (fFalse)
#define FSuceeded(err) (!err)
#define FFailed(err) (err)

#define F(x) ((x) ? fTrue : fFalse)


#define tblRedrawFieldEvent			((UInt)firstUserEvent + 0)
#define tblDeleteAndReloadEvent		((UInt)firstUserEvent + 1)


void Error(UInt idsErr);

VoidPtr GetObjectPtr(Int objectID);
FieldPtr GetFocusObjectPtr(void);
CharPtr _FldGetTextPtr(FieldPtr pfld);

void InvertEditIndicator(TablePtr ptbl, Word row);
void DrawBlankField(FieldPtr pfld);
void DrawHelpButton(FormPtr pfrm, UInt idc);
UInt TruncateLabel(CharPtr psz, Int cxMax);
Int CalcRowHeight(CharPtr psz, Int cx, Int cyLinesAvailable);

Int GetStoreIndex(UInt store);
void SetStoreTrigger(void);
Word GetItemStore(UInt record);

void UpdateCounts(Int delta, UInt bits);
void DeleteRecord(UInt record);
Boolean FCanDelete(TablePtr ptbl, UInt record);
Boolean SetCurrentRecord(UInt record);

#if 0
void SendPenDownEvent(PointType *ppt);
#endif
void SendUpdateTableFieldRedraw(TablePtr ptbl);
void SendDeleteAndReloadTable(TablePtr ptbl, UInt record);

CharPtr LocalizeNumber(ULong ul, Boolean fCurrencySymbol, Boolean fForceDecimals, UInt *pcch);

VoidHand GetFilteredRecord(DmOpenRef pdb, UInt *piRecord, UInt category, UInt store, UInt view, Int cRecords, Int direction);
void ExportToMemoPad(void);

extern UInt s_record;
void SaveInsPt(void);
void RestoreInsPt(void);
void DiscardSavedInsPt(void);

Boolean HandleEditMenu(EventPtr pEvent);


